/* SPDX-FileCopyrightText: © 2024-2025 Decompollaborate */
/* SPDX-License-Identifier: MIT */

pub use crate::generated::Abi;

impl Abi {
    /// Returns a default value.
    ///
    /// Defaults to [`O32`].
    ///
    /// [`O32`]: Abi::O32
    #[must_use]
    pub const fn default() -> Self {
        Self::O32
    }
}

impl Default for Abi {
    fn default() -> Self {
        Self::default()
    }
}

impl From<&str> for Abi {
    fn from(value: &str) -> Self {
        match value {
            "32" | "o32" | "O32" => Self::O32,
            "n32" | "N32" => Self::N32,
            "64" | "n64" | "N64" => Self::N64,
            _ => Self::O32,
        }
    }
}
